﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private B4XTable1 As B4XTable
	Private B4XPlusMinus1 As B4XPlusMinus
	Private TextField1 As B4XView
	Private ColorsList As List
	Private ie As InlineEditing
		
End Sub


Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	Root.LoadLayout("Controls")
	ie.Initialize(B4XTable1, Me, "ie")
	B4XPages.AddPage("InlineEditing", ie)

	B4XPlusMinus1.mBase.RemoveViewFromParent
	TextField1.RemoveViewFromParent
'	B4XPages.AddPage("InlineEditing", ie)
	
	ColorsList = Array("Red", "Green", "Blue")
	B4XTable1.AddColumn("Number", B4XTable1.COLUMN_TYPE_NUMBERS)
	B4XTable1.AddColumn("String", B4XTable1.COLUMN_TYPE_TEXT)
	B4XTable1.AddColumn("Color", B4XTable1.COLUMN_TYPE_TEXT)
	B4XTable1.AddColumn("Date", B4XTable1.COLUMN_TYPE_DATE)
	Dim data As List
	data.Initialize
	For i = 1 To 50
		Dim row() As Object = Array(Rnd(1, 100), "Item #" & i, ColorsList.Get(i Mod ColorsList.Size), DateTime.Now)
		data.Add(row)
	Next
	B4XTable1.SetData(data)

End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.




Private Sub MainForm_Resize (Width As Double, Height As Double)
	ie.TableResized
End Sub

Sub B4XTable1_CellClicked (ColumnId As String, RowId As Long)
	'avoid calling ie.CellClicked if the column is not editable.
	ie.CellClicked(ColumnId, RowId)
End Sub

Sub B4XTable1_DataUpdated
	ie.DataUpdated
End Sub

Private Sub IE_EnterEditMode (FC As FocusedCell)
	'FC.PrevValue holds the current value. It can also be used later to revert changes
	Select FC.ColumnId
		Case "Number"
			B4XPlusMinus1.SetNumericRange(0, 5, 1)
			B4XPlusMinus1.SelectedValue = FC.PrevValue
			FC.View = B4XPlusMinus1.mBase
		Case "String"
			SetTextField
			TextField1.Text = FC.PrevValue
			FC.View = TextField1
		Case "Color"
			B4XPlusMinus1.SetStringItems(ColorsList)
			B4XPlusMinus1.SelectedValue = FC.PrevValue
			FC.View = B4XPlusMinus1.mBase
		Case "Date"
			SetTextField
			TextField1.Text = DateTime.Date(FC.PrevValue)
			FC.View = TextField1
	End Select
End Sub

Private Sub IE_GetUpdatedValue (FC As FocusedCell) As Object
	Select FC.ColumnId
		Case "Number"
			Return B4XPlusMinus1.SelectedValue
		Case "String"
			Return TextField1.Text
		Case "Color"
			Return B4XPlusMinus1.SelectedValue
		Case "Date"
			Try
				Return DateTime.DateParse(TextField1.Text)
			Catch
				Return FC.PrevValue
			End Try
	End Select
	Return Null
End Sub

Private Sub SetTextField
	TextField1.SetColorAndBorder(xui.Color_Transparent, 0, 0, 0)
	Dim tf As EditText= TextField1
	Sleep(0)
	tf.SelectAll
End Sub

Sub TextField1_Action
	ie.ExitEditMode
End Sub

Sub TextField1_TextChanged (Old As String, New As String)
	If ie.IsInEditingState And ie.CurrentlyFocusedCell.ColumnId = "Date" Then
		Try
			DateTime.DateParse(New)
			TextField1.SetColorAndBorder(xui.Color_Transparent, 0, 0, 0)
		Catch
			TextField1.SetColorAndBorder(xui.Color_Transparent, 2, xui.Color_Red, 0)
		End Try
	End If
End Sub

